#ifndef SENSOR_HPP
#define SENSOR_HPP

#include <Arduino.h>

#include <DallasTemperature.h>

class Sensor {
	private:
	uint16_t id;
	uint8_t resolution;
	float accuracy;
	DallasTemperature &bus;
	DeviceAddress address;

	public:
	static constexpr uint16_t serializedSize = sizeof(id) + sizeof(resolution) + sizeof(accuracy);
	static constexpr uint16_t dataPacketMaxSize = 256;


	Sensor(int id, float resolution, float accuracy, DallasTemperature &bus, DeviceAddress address);

	float read() const;

	uint16_t getId() const {return id;};

	uint16_t makeDataPacket(byte (&buffer)[dataPacketMaxSize]) const;

	void registerSensor(byte (&buffer)[serializedSize]) const;
};

#endif